VERSION 5.00
Begin VB.Form Nubefact-json
   Caption         =   "Nubefact"
   ClientHeight    =   3030
   ClientLeft      =   120
   ClientTop       =   450
   ClientWidth     =   4560
   LinkTopic       =   "Form1"
   ScaleHeight     =   3030
   ScaleWidth      =   4560
   StartUpPosition =   3  'Windows Default
   Begin VB.CommandButton Command1 
      Caption         =   "Command1"
      Height          =   1095
      Left            =   1320
      TabIndex        =   0
      Top             =   960
      Width           =   2895
   End
End
Attribute VB_Name = "Nubefact-json"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Private Sub Command1_Click()

' #########################################################
' #### INTEGRACIN FCIL ####
' +++++++++++++++++++++++++++++++++++++++++++++++++++++++
' # ESTE CDIGO FUNCIONA PARA LA VERSIN ONLINE Y OFFLINE
' # Visita www.nubefact.com/integracion para ms informacin
' +++++++++++++++++++++++++++++++++++++++++++++++++++++++


' #########################################################
' #### FORMA DE TRABAJO ####
' +++++++++++++++++++++++++++++++++++++++++++++++++++++++
' # PASO 1: Conseguir una RUTA y un TOKEN para trabajar con NUBEFACT (Regstrate o ingresa a tu cuenta en www.nubefact.com).
' # PASO 2: Generar un archivo en formato .JSON o .TXT con una estructura que se detalla en este documento.
' # PASO 3: Enviar el archivo generado a nuestra WEB SERVICE ONLINE u OFFLINE segn corresponda usando la RUTA y el TOKEN.
' # PASO 4: Generamos el archivo XML y PDF (Segn especificaciones de la SUNAT) y te devolveremos INSTANTNEAMENTE los datos del documento generado.
' # Para ver el documento generado ingresa a www.nubefact.com/login con tus datos de acceso, y luego a la opcin "Ver Facturas, Boletas y Notas"
' # IMPORTANTE: Enviaremos el XML generado a la SUNAT y lo almacenaremos junto con el PDF, XML y CDR en la NUBE para que tu cliente pueda consultarlo en cualquier momento, si as lo desea.
' +++++++++++++++++++++++++++++++++++++++++++++++++++++++


' #########################################################
' #### PASO 1: CONSEGUIR LA RUTA Y TOKEN ####
' +++++++++++++++++++++++++++++++++++++++++++++++++++++++
' # CUENTA DEMO PARA HACER PRUEBAS
' # Puedes usar la siguiente cuenta para hacer pruebas:
' #  - LINK: https://demo.nubefact.com/login
' #  - USUARIO: demo@nubefact.com
' #  - PASSWORD: demo@nubefact.com
' # Una vez que ingreses a esta cuenta ve a la opcin API (Integracin) para ver la RUTA y el TOKEN los cuales son:
' #  - RUTA: https://demo.nubefact.com/api/v1/03989d1a-6c8c-4b71-b1cd-7d37001deaa0
' #  - TOKEN: d0a80b88cde446d092025465bdb4673e103a0d881ca6479ebbab10664dbc5677
' # Tambin puedes crear una cuenta propia para hacer pruebas ms precisas.
' #
' # CREAR UNA CUENTA PROPIA
' #  - Regstrate gratis en www.nubefact.com/register
' #  - Ir la opcin API (Integracin).
' # IMPORTANTE: Para que la opcin API (Integracin) de tu cuenta propia est activada necesitas escribirnos a soporte@nubefact.com o llmanos al telfono: 01 468 3535 (opcin 2) o celular (WhatsApp) 955 598762.
' +++++++++++++++++++++++++++++++++++++++++++++++++++++++

' PASO 2: USAR LA RUTA Y TOKEN
' Conseguir una RUTA y un TOKEN para trabajar con NUBEFACT (Regstrate o ingresa a tu cuenta en www.nubefact.com)

Dim ruta, token As String

' RUTA para enviar documentos
ruta = "https://demo.nubefact.com/api/v1/03989d1a-6c8c-4b71-b1cd-7d37001deaa0"

' TOKEN para enviar documentos
token = "d0a80b88cde446d092025465bdb4673e103a0d881ca6479ebbab10664dbc5677"

' #########################################################
' #### PASO 2: GENERAR EL ARCHIVO PARA ENVIAR A NUBEFACT ####
' +++++++++++++++++++++++++++++++++++++++++++++++++++++++
' # - MANUAL para archivo JSON en el link: https://goo.gl/WHMmSb
' # - MANUAL para archivo TXT en el link: https://goo.gl/Lz7hAq
' +++++++++++++++++++++++++++++++++++++++++++++++++++++++
' CREAMOS LAS CLASES PARA CONSTRUIR EL JSON Y LEER LA RESPUESTA EN JSON

Dim JsonParaEnviar As Object
Dim crear_json_para_enviar As String

' Vamos a crear unas cuantas variables como ejemplo
Dim tipo, serie, numero As String
tipo = """1"""
serie = """FFF1"""
numero = """1"""
' Aqu construimos el archivo JSON
crear_json_para_enviar = crear_json_para_enviar & "{"
   crear_json_para_enviar = crear_json_para_enviar & """operacion"": ""generar_comprobante"","
   crear_json_para_enviar = crear_json_para_enviar & """tipo_de_comprobante"": " & tipo & ","
   crear_json_para_enviar = crear_json_para_enviar & """serie"": ""FFF1"","
   crear_json_para_enviar = crear_json_para_enviar & """numero"": ""1"","
   crear_json_para_enviar = crear_json_para_enviar & """sunat_transaction"": ""1"","
   crear_json_para_enviar = crear_json_para_enviar & """cliente_tipo_de_documento"": ""6"","
   crear_json_para_enviar = crear_json_para_enviar & """cliente_numero_de_documento"": ""20600695771"","
   crear_json_para_enviar = crear_json_para_enviar & """cliente_denominacion"": ""NUBEFACTSA"","
   crear_json_para_enviar = crear_json_para_enviar & """cliente_direccion"": ""CALLE LIBERTAD 116 MIRAFLORES - LIMA - PERU"","
   crear_json_para_enviar = crear_json_para_enviar & """cliente_email"": """","
   crear_json_para_enviar = crear_json_para_enviar & """cliente_email_1"": """","
   crear_json_para_enviar = crear_json_para_enviar & """cliente_email_2"": """","
   crear_json_para_enviar = crear_json_para_enviar & """fecha_de_emision"": ""10-05-2017"","
   crear_json_para_enviar = crear_json_para_enviar & """fecha_de_vencimiento"": """","
   crear_json_para_enviar = crear_json_para_enviar & """moneda"": ""1"","
   crear_json_para_enviar = crear_json_para_enviar & """tipo_de_cambio"": """","
   crear_json_para_enviar = crear_json_para_enviar & """porcentaje_de_igv"": ""18"","
   crear_json_para_enviar = crear_json_para_enviar & """descuento_global"": """","
   crear_json_para_enviar = crear_json_para_enviar & """total_descuento"": """","
   crear_json_para_enviar = crear_json_para_enviar & """total_anticipo"": """","
   crear_json_para_enviar = crear_json_para_enviar & """total_gravada"": ""600"","
   crear_json_para_enviar = crear_json_para_enviar & """total_inafecta"": """","
   crear_json_para_enviar = crear_json_para_enviar & """total_exonerada"": """","
   crear_json_para_enviar = crear_json_para_enviar & """total_igv"": ""108"","
   crear_json_para_enviar = crear_json_para_enviar & """total_gratuita"": """","
   crear_json_para_enviar = crear_json_para_enviar & """total_otros_cargos"": """","
   crear_json_para_enviar = crear_json_para_enviar & """total"": ""708"","
   crear_json_para_enviar = crear_json_para_enviar & """percepcion_tipo"": """","
   crear_json_para_enviar = crear_json_para_enviar & """percepcion_base_imponible"": """","
   crear_json_para_enviar = crear_json_para_enviar & """total_percepcion"": """","
   crear_json_para_enviar = crear_json_para_enviar & """total_incluido_percepcion"": """","
   crear_json_para_enviar = crear_json_para_enviar & """detraccion"": ""false"","
   crear_json_para_enviar = crear_json_para_enviar & """observaciones"": """","
   crear_json_para_enviar = crear_json_para_enviar & """documento_que_se_modifica_tipo"": """","
   crear_json_para_enviar = crear_json_para_enviar & """documento_que_se_modifica_serie"": """","
   crear_json_para_enviar = crear_json_para_enviar & """documento_que_se_modifica_numero"": """","
   crear_json_para_enviar = crear_json_para_enviar & """tipo_de_nota_de_credito"": """","
   crear_json_para_enviar = crear_json_para_enviar & """tipo_de_nota_de_debito"": """","
   crear_json_para_enviar = crear_json_para_enviar & """enviar_automaticamente_a_la_sunat"": ""true"","
   crear_json_para_enviar = crear_json_para_enviar & """enviar_automaticamente_al_cliente"": ""false"","
   crear_json_para_enviar = crear_json_para_enviar & """codigo_unico"": """","
   crear_json_para_enviar = crear_json_para_enviar & """condiciones_de_pago"": """","
   crear_json_para_enviar = crear_json_para_enviar & """medio_de_pago"": """","
   crear_json_para_enviar = crear_json_para_enviar & """placa_vehiculo"": """","
   crear_json_para_enviar = crear_json_para_enviar & """orden_compra_servicio"": """","
   crear_json_para_enviar = crear_json_para_enviar & """tabla_personalizada_codigo"": """","
   crear_json_para_enviar = crear_json_para_enviar & """formato_de_pdf"": """","
   crear_json_para_enviar = crear_json_para_enviar & """items"": ["
           crear_json_para_enviar = crear_json_para_enviar & "{"
           crear_json_para_enviar = crear_json_para_enviar & """unidad_de_medida"": ""NIU"","
           crear_json_para_enviar = crear_json_para_enviar & """codigo"": ""001"","
           crear_json_para_enviar = crear_json_para_enviar & """descripcion"": ""DETALLE DEL PRODUCTO"","
           crear_json_para_enviar = crear_json_para_enviar & """cantidad"": ""1"","
           crear_json_para_enviar = crear_json_para_enviar & """valor_unitario"": ""500"","
           crear_json_para_enviar = crear_json_para_enviar & """precio_unitario"": ""500"","
           crear_json_para_enviar = crear_json_para_enviar & """descuento"": """","
           crear_json_para_enviar = crear_json_para_enviar & """subtotal"": ""500"","
           crear_json_para_enviar = crear_json_para_enviar & """tipo_de_igv"": ""6"","
           crear_json_para_enviar = crear_json_para_enviar & """igv"": ""90"","
           crear_json_para_enviar = crear_json_para_enviar & """total"": ""500"","
           crear_json_para_enviar = crear_json_para_enviar & """anticipo_regularizacion"": ""false"","
           crear_json_para_enviar = crear_json_para_enviar & """anticipo_documento_serie"": """","
           crear_json_para_enviar = crear_json_para_enviar & """anticipo_documento_numero"": """""
           crear_json_para_enviar = crear_json_para_enviar & "}," ' CUIDADO: Retirar la coma si es la ltima linea o item del documento
           crear_json_para_enviar = crear_json_para_enviar & "{"
           crear_json_para_enviar = crear_json_para_enviar & """unidad_de_medida"": ""NIU"","
           crear_json_para_enviar = crear_json_para_enviar & """codigo"": ""001"","
           crear_json_para_enviar = crear_json_para_enviar & """descripcion"": ""DETALLE DEL PRODUCTO"","
           crear_json_para_enviar = crear_json_para_enviar & """cantidad"": ""1"","
           crear_json_para_enviar = crear_json_para_enviar & """valor_unitario"": ""100"","
           crear_json_para_enviar = crear_json_para_enviar & """precio_unitario"": ""118"","
           crear_json_para_enviar = crear_json_para_enviar & """descuento"": """","
           crear_json_para_enviar = crear_json_para_enviar & """subtotal"": ""100"","
           crear_json_para_enviar = crear_json_para_enviar & """tipo_de_igv"": ""1"","
           crear_json_para_enviar = crear_json_para_enviar & """igv"": ""18"","
           crear_json_para_enviar = crear_json_para_enviar & """total"": ""118"","
           crear_json_para_enviar = crear_json_para_enviar & """anticipo_regularizacion"": ""false"","
           crear_json_para_enviar = crear_json_para_enviar & """anticipo_documento_serie"": """","
           crear_json_para_enviar = crear_json_para_enviar & """anticipo_documento_numero"": """""
           crear_json_para_enviar = crear_json_para_enviar & "}" ' CUIDADO: Retirar la coma si es la ltima linea o item del documento
   crear_json_para_enviar = crear_json_para_enviar & "]"
crear_json_para_enviar = crear_json_para_enviar & "}"

Set JsonParaEnviar = JsonConverter.ParseJson(crear_json_para_enviar)


' #########################################################
' #### PASO 3: ENVIAR EL ARCHIVO A NUBEFACT ####
' +++++++++++++++++++++++++++++++++++++++++++++++++++++++
' # SI ESTS TRABAJANDO CON ARCHIVO JSON
' # - Debes enviar en el HEADER de tu solicitud la siguiente lo siguiente:
' # Authorization = Token token="8d19d8c7c1f6402687720eab85cd57a54f5a7a3fa163476bbcf381ee2b5e0c69"
' # Content-Type = application/json
' # - Adjuntar en el CUERPO o BODY el archivo JSON o TXT
' # SI ESTS TRABAJANDO CON ARCHIVO TXT
' # - Debes enviar en el HEADER de tu solicitud la siguiente lo siguiente:
' # Authorization = Token token="8d19d8c7c1f6402687720eab85cd57a54f5a7a3fa163476bbcf381ee2b5e0c69"
' # Content-Type = text/plain
' # - Adjuntar en el CUERPO o BODY el archivo JSON o TXT
' +++++++++++++++++++++++++++++++++++++++++++++++++++++++

' Aqu invocamos el servicio de NUBEFACT va http POST y enviamos el ARCHIVO JSON ya GENERADO usando la RUTA y el TOKEN

MsgBox "Este es el archivo JSON que se enviar: " & JsonConverter.ConvertToJson(JsonParaEnviar)

Dim myMSXML
Set myMSXML = CreateObject("Microsoft.XmlHttp")
' Para algunas versiones de XMLHTTP, usar:
'   Set myMSXML = CreateObject("MSXML2.ServerXMLHTTP")
'   Set myMSXML = CreateObject("MSXML2.XMLHTTP")
myMSXML.open "POST", ruta, False
myMSXML.setRequestHeader "Content-Type", "application/json"
myMSXML.setRequestHeader "Authorization", "Token token=" & token
myMSXML.send JsonConverter.ConvertToJson(JsonParaEnviar)

' #########################################################
' #### PASO 4: LEER RESPUESTA DE NUBEFACT ####
' +++++++++++++++++++++++++++++++++++++++++++++++++++++++
' # Recibirs una respuesta de NUBEFACT inmediatamente lo cual se debe leer, verificando que no haya errores.
' # Debes guardar en la base de datos la respuesta que te devolveremos.
' # Escrbenos a soporte@nubefact.com o llmanos al telfono: 01 468 3535 (opcin 2) o celular (WhatsApp) 955 598762
' # Puedes imprimir el PDF que nosotros generamos como tambin generar tu propia representacin impresa previa coordinacin con nosotros.
' # La impresin del documento seguir hacindose desde tu sistema. Enviaremos el documento por email a tu cliente si as lo indicas en el archivo JSON o TXT.
' +++++++++++++++++++++++++++++++++++++++++++++++++++++++

Dim JsonDeRespuesta As String
Dim RespuestaEnJson As Dictionary
JsonDeRespuesta = myMSXML.responseText
Set RespuestaEnJson = JsonConverter.ParseJson(JsonDeRespuesta)
If RespuestaEnJson("errors") = "" Then
   MsgBox "TIPO: " & RespuestaEnJson("tipo_de_comprobante")
   MsgBox "SERIE: " & RespuestaEnJson("serie")
   MsgBox "NUMERO: " & RespuestaEnJson("numero")
   MsgBox "ENLACE: " & RespuestaEnJson("enlace")
   MsgBox "ACEPTADA_POR_SUNAT: " & RespuestaEnJson("aceptada_por_sunat")
   MsgBox "SUNAT_DESCRIPTION: " & RespuestaEnJson("sunat_description")
   MsgBox "SUNAT_NOTE: " & RespuestaEnJson("sunat_note")
   MsgBox "SUNAT_RESPONSECODE: " & RespuestaEnJson("sunat_responsecode")
   MsgBox "SUNAT_SOAP_ERROR: " & RespuestaEnJson("sunat_soap_error")
   MsgBox "PDF_ZIP_BASE64: " & RespuestaEnJson("pdf_zip_base64")
   MsgBox "XML_ZIP_BASE64: " & RespuestaEnJson("xml_zip_base64")
   MsgBox "CDR_ZIP_BASE64: " & RespuestaEnJson("cdr_zip_base64")
   MsgBox "CADENA_PARA_CODIGO_QR: " & RespuestaEnJson("cadena_para_codigo_qr")
   MsgBox "CODIGO_HASH: " & RespuestaEnJson("codigo_hash")
Else
   MsgBox "Existen Errores: " & RespuestaEnJson("errors")
End If
End Sub
